searchNodes=[{"doc":"High level bitcoin operations","ref":"BitcoinLib.html","title":"BitcoinLib","type":"module"},{"doc":"Derives a public key from a raw private key Examples iex&gt; 0x0a8d286b11b98f6cb2585b627ff44d12059560acd430dcfa1260ef2bd9569373 ...&gt; |&gt; BitcoinLib.derive_public_key() { 0x040f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053002119e16b613619691f760eadd486315fc9e36491c7adb76998d1b903b3dd12 , 0x020f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053 }","ref":"BitcoinLib.html#derive_public_key/1","title":"BitcoinLib.derive_public_key/1","type":"function"},{"doc":"Creates a P2PKH address from a public key Examples iex&gt; 0x020f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053 ...&gt; |&gt; BitcoinLib.generate_p2pkh_address() &quot;1Ak9NVPmwCHEpsSWvM6cNRC7dsYniRmwMG&quot;","ref":"BitcoinLib.html#generate_p2pkh_address/1","title":"BitcoinLib.generate_p2pkh_address/1","type":"function"},{"doc":"Creates a bitcoin private key both in raw and WIF format Examples iex&gt; %{raw: , wif: } = BitcoinLib.generate_private_key()","ref":"BitcoinLib.html#generate_private_key/0","title":"BitcoinLib.generate_private_key/0","type":"function"},{"doc":"","ref":"BitcoinLib.Console.html","title":"BitcoinLib.Console","type":"module"},{"doc":"","ref":"BitcoinLib.Console.html#write/2","title":"BitcoinLib.Console.write/2","type":"function"},{"doc":"Cryptography functions","ref":"BitcoinLib.Crypto.html","title":"BitcoinLib.Crypto","type":"module"},{"doc":"Takes any hexadecimal value as a string and creates a double-sha256, keeping only the first 4 bytes Examples iex&gt; &quot;806c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a590737610701&quot; ...&gt; |&gt; BitcoinLib.Crypto.checksum() &quot;b56c36b1&quot;","ref":"BitcoinLib.Crypto.html#checksum/1","title":"BitcoinLib.Crypto.checksum/1","type":"function"},{"doc":"Takes any binary and creates a double-sha256, keeping only the first 4 bytes Examples iex&gt; value = &lt;&lt;128, 108, 122, 178, 249, 97, 161, 188, 63, 19, 205, 192, 141, 196, 28, 63, 67&gt;&gt; ...&gt; value = value &lt;&gt; &lt;&lt;154, 222, 189, 84, 154, 142, 241, 192, 137, 232, 26, 89, 7, 55, 97, 7, 1&gt;&gt; ...&gt; value |&gt; BitcoinLib.Crypto.checksum_bitstring() &lt;&lt;181, 108, 54, 177&gt;&gt;","ref":"BitcoinLib.Crypto.html#checksum_bitstring/1","title":"BitcoinLib.Crypto.checksum_bitstring/1","type":"function"},{"doc":"Computes SHA256 twice in a row on an arbitrary string Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; BitcoinLib.Crypto.double_sha256() &quot;de43342f6e8bcc34d95f36e4e1b8eab957a0ce2ff3b0e183142d91a871170f2b&quot;","ref":"BitcoinLib.Crypto.html#double_sha256/1","title":"BitcoinLib.Crypto.double_sha256/1","type":"function"},{"doc":"Computes SHA256 twice on a binary and returns it as a binary Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; BitcoinLib.Crypto.double_sha256_bitstring() &lt;&lt;222, 67, 52, 47, 110, 139, 204, 52, 217, 95, 54, 228, 225, 184, 234, 185, 87, 160, 206, 47, 243, 176, 225, 131, 20, 45, 145, 168, 113, 23, 15, 43&gt;&gt;","ref":"BitcoinLib.Crypto.html#double_sha256_bitstring/1","title":"BitcoinLib.Crypto.double_sha256_bitstring/1","type":"function"},{"doc":"Computes a hash160 of a bitstring, which is the ripemd160 of a sha256 Examples iex&gt; &lt;&lt;128, 0, 0, 44&gt;&gt; ...&gt; |&gt; BitcoinLib.Crypto.hash160_bitstring() &lt;&lt;251, 126, 153, 20, 166, 224, 56, 154, 55, 180, 46, 3, 58, 245, 19, 162, 196, 12, 64, 2&gt;&gt;","ref":"BitcoinLib.Crypto.html#hash160_bitstring/1","title":"BitcoinLib.Crypto.hash160_bitstring/1","type":"function"},{"doc":"Computes HMAC on an arbitrary string Examples iex&gt; seed = &quot;b1680c7a6ea6ed5ac9bf3bc3b43869a4c77098e60195bae51a94159333820e125c3409b8c8d74b4489f28ce71b06799b1126c1d9620767c2dadf642cf787cf36&quot; ...&gt; key = &quot;Bitcoin seed&quot; ...&gt; BitcoinLib.Crypto.hmac(seed, key) &quot;1f22e99440b621e47e74a779ce4063c497846ab118fa2531a49611d43dca5787ea2d0fb95937144c4fe3730b6e656895d0e30defa312b164727ca4cdd3530b43&quot;","ref":"BitcoinLib.Crypto.html#hmac/2","title":"BitcoinLib.Crypto.hmac/2","type":"function"},{"doc":"Computes HMAC on a binary and returns it as a binary Examples iex&gt; seed = &quot;b1680c7a6ea6ed5ac9bf3bc3b43869a4c77098e60195bae51a94159333820e125c3409b8c8d74b4489f28ce71b06799b1126c1d9620767c2dadf642cf787cf36&quot; ...&gt; key = &quot;Bitcoin seed&quot; ...&gt; BitcoinLib.Crypto.hmac_bitstring(seed, key) &lt;&lt;31, 34, 233, 148, 64, 182, 33, 228, 126, 116, 167, 121, 206, 64, 99, 196, 151, 132, 106, 177, 24, 250, 37, 49, 164, 150, 17, 212, 61, 202, 87, 135, 234, 45, 15, 185, 89, 55, 20, 76, 79, 227, 115, 11, 110, 101, 104, 149, 208, 227, 13, 239, 163, 18, 177, 100, 114, 124, 164, 205, 211, 83, 11, 67&gt;&gt;","ref":"BitcoinLib.Crypto.html#hmac_bitstring/2","title":"BitcoinLib.Crypto.hmac_bitstring/2","type":"function"},{"doc":"Computes RIPEMD160 on an arbitrary string Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; BitcoinLib.Crypto.ripemd160() &quot;f23d97252131c60666708e4ae2c59fed1349f439&quot;","ref":"BitcoinLib.Crypto.html#ripemd160/1","title":"BitcoinLib.Crypto.ripemd160/1","type":"function"},{"doc":"Computes RIPEMD160 on a binary and returns it as a binary Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; BitcoinLib.Crypto.ripemd160_bitstring() &lt;&lt;242, 61, 151, 37, 33, 49, 198, 6, 102, 112, 142, 74, 226, 197, 159, 237, 19, 73, 244, 57&gt;&gt;","ref":"BitcoinLib.Crypto.html#ripemd160_bitstring/1","title":"BitcoinLib.Crypto.ripemd160_bitstring/1","type":"function"},{"doc":"Computes a point on the ellpitic curve on a binary and returns it as a binary Examples iex&gt; value = &lt;&lt;0xD6, 0xEA, 0xD2, 0x33, 0xE0, 0x6C, 0x6, 0x85, 0x85, 0x97, 0x6B, 0x5C, 0x83, ...&gt; 0x73, 0x86, 0x1D, 0x77, 0xE7, 0xF0, 0x30, 0xEC, 0x45, 0x2E, 0x65, 0xEE, 0x81, ...&gt; 0xC8, 0x5F, 0xA6, 0x90, 0x69, 0x70&gt;&gt; ...&gt; BitcoinLib.Crypto.secp256k1_bitstring(value) &lt;&lt;4, 112, 45, 237, 28, 202, 152, 22, 250, 26, 148, 120, 127, 252, 111, 58, 206, 98 , 205 , 59 , 99 , 22 , 79 , 118 , 210 , 39 , 208 , 147 , 90 , 51 , 238 , 72 , 195 , 86 , 255 , 200 , 70 , 166 , 27 , 12 , 103 , 60 , 186 , 204 , 246 , 36 , 62 , 191 , 55 , 255 , 91 , 162 , 76 , 111 , 113 , 88 , 193 , 139 , 127 , 168 , 9 , 13 , 240 , 215 , 228 &gt;&gt;","ref":"BitcoinLib.Crypto.html#secp256k1_bitstring/1","title":"BitcoinLib.Crypto.secp256k1_bitstring/1","type":"function"},{"doc":"Computes SHA1 on an arbitrary string Examples iex&gt; &quot;806c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a590737610701&quot; ...&gt; |&gt; BitcoinLib.Crypto.sha1() &quot;1c90d51061e90f9483d89cb23525a5f1de323cd8&quot;","ref":"BitcoinLib.Crypto.html#sha1/1","title":"BitcoinLib.Crypto.sha1/1","type":"function"},{"doc":"Computes SHA1 on a binary and returns it as a binary Examples iex&gt; &quot;806c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a590737610701&quot; ...&gt; |&gt; BitcoinLib.Crypto.sha1_bitstring() &lt;&lt;28, 144, 213, 16, 97, 233, 15, 148, 131, 216, 156, 178, 53, 37, 165, 241, 222, 50, 60, 216&gt;&gt;","ref":"BitcoinLib.Crypto.html#sha1_bitstring/1","title":"BitcoinLib.Crypto.sha1_bitstring/1","type":"function"},{"doc":"Computes SHA256 on an arbitrary string Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; BitcoinLib.Crypto.sha256() &quot;ab6a8f1d9e2b0333dff8e370ed6fdfe20b2e8008e045efb3fb3298c22f7569da&quot;","ref":"BitcoinLib.Crypto.html#sha256/1","title":"BitcoinLib.Crypto.sha256/1","type":"function"},{"doc":"Computes SHA256 on a binary and returns it as a binary Examples iex&gt; &quot;6c7ab2f961a1bc3f13cdc08dc41c3f439adebd549a8ef1c089e81a5907376107&quot; ...&gt; |&gt; BitcoinLib.Crypto.sha256_bitstring() &lt;&lt;171, 106, 143, 29, 158, 43, 3, 51, 223, 248, 227, 112, 237, 111, 223, 226, 11, 46, 128, 8, 224, 69, 239, 179, 251, 50, 152, 194, 47, 117, 105, 218&gt;&gt;","ref":"BitcoinLib.Crypto.html#sha256_bitstring/1","title":"BitcoinLib.Crypto.sha256_bitstring/1","type":"function"},{"doc":"Bitwise operations","ref":"BitcoinLib.Crypto.BitUtils.html","title":"BitcoinLib.Crypto.BitUtils","type":"module"},{"doc":"Regroups a list of binaries into a single one Examples iex&gt; [&lt;&lt;6, 6::size(3)&gt;&gt;, &lt;&lt;61, 2::size(3)&gt;&gt;, &lt;&lt;203, 7::size(3)&gt;&gt;, &lt;&lt;44, 1::size(3)&gt;&gt;, &lt;&lt;10::size(4)&gt;&gt;] ...&gt; |&gt; BitcoinLib.Crypto.BitUtils.combine &lt;&lt;6, 199, 171, 47, 150, 26&gt;&gt;","ref":"BitcoinLib.Crypto.BitUtils.html#combine/1","title":"BitcoinLib.Crypto.BitUtils.combine/1","type":"function"},{"doc":"Converts a binary into a list of smaller binaries according to the bit size specification Examples iex&gt; 0x6C7AB2F961A ...&gt; |&gt; Binary.from_integer() ...&gt; |&gt; BitcoinLib.Crypto.BitUtils.split(11) [ &lt;&lt; 6 , 6 :: size ( 3 ) &gt;&gt; , &lt;&lt; 61 , 2 :: size ( 3 ) &gt;&gt; , &lt;&lt; 203 , 7 :: size ( 3 ) &gt;&gt; , &lt;&lt; 44 , 1 :: size ( 3 ) &gt;&gt; , &lt;&lt; 10 :: size ( 4 ) &gt;&gt; ]","ref":"BitcoinLib.Crypto.BitUtils.html#split/2","title":"BitcoinLib.Crypto.BitUtils.split/2","type":"function"},{"doc":"Cryptography helper functions","ref":"BitcoinLib.Crypto.Convert.html","title":"BitcoinLib.Crypto.Convert","type":"module"},{"doc":"Converts an integer, most probably a private key, into a 0 padded binary of a fix length Examples iex&gt; 0x0A8D286B11B98F6CB2585B627FF44D12059560ACD430DCFA1260EF2BD9569373 ...&gt; |&gt; BitcoinLib.Crypto.Convert.integer_to_binary() &lt;&lt; 10, 141, 40, 107, 17, 185, 143, 108, 178, 88, 91 , 98 , 127 , 244 , 77 , 18 , 5 , 149 , 96 , 172 , 212 , 48 , 220 , 250 , 18 , 96 , 239 , 43 , 217 , 86 , 147 , 115 &gt;&gt;","ref":"BitcoinLib.Crypto.Convert.html#integer_to_binary/2","title":"BitcoinLib.Crypto.Convert.integer_to_binary/2","type":"function"},{"doc":"Elliptic curve cryptography Based on https://hexdocs.pm/curvy/Curvy.html","ref":"BitcoinLib.Crypto.Secp256k1.html","title":"BitcoinLib.Crypto.Secp256k1","type":"module"},{"doc":"Add two keys on the elliptic curve using Jacobian Point mathematics Examples iex&gt; key1 = 0x2E65A9C40338B8D07D72CD82BF3C9DDD0375F362863BC0808E6AD194F19F5EBA0 ...&gt; key2 = 0x2702DED1CCA9816FA1A94787FFC6F3ACE62CD3B63164F76D227D0935A33EE48C3 ...&gt; BitcoinLib.Crypto.Secp256k1.add_keys(key1, key2) 0x2FC5BA55A539899D67EE66E99EE50AB59DCCBB122025D18C5EB9446D380A9EC0A","ref":"BitcoinLib.Crypto.Secp256k1.html#add_keys/2","title":"BitcoinLib.Crypto.Secp256k1.add_keys/2","type":"function"},{"doc":"WIF Bitcoin private key format management Inspired by https://learnmeabitcoin.com/technical/wif","ref":"BitcoinLib.Crypto.Wif.html","title":"BitcoinLib.Crypto.Wif","type":"module"},{"doc":"Converts a raw private key to the WIF format Examples iex&gt; 0x0A8D286B11B98F6CB2585B627FF44D12059560ACD430DCFA1260EF2BD9569373 ...&gt; |&gt; BitcoinLib.Crypto.Wif.from_integer &quot;KwaDo7PNi4XPMaABfSEo9rP6uviDUATAqvyjjWTcKp4fxdkVJWLe&quot;","ref":"BitcoinLib.Crypto.Wif.html#from_integer/2","title":"BitcoinLib.Crypto.Wif.from_integer/2","type":"function"},{"doc":"Bitcoin address management Inspired by https://learnmeabitcoin.com/technical/public-key-hash","ref":"BitcoinLib.Key.Address.html","title":"BitcoinLib.Key.Address","type":"module"},{"doc":"Convert public key hash into a P2PKH Bitcoin address. Details can be found here: https://en.bitcoin.it/wiki/Technical_background_of_version_1_Bitcoin_addresses Examples iex&gt; 0x6ae201797de3fa7d1d95510f50c1a9c50ce4cc36 ...&gt; |&gt; BitcoinLib.Key.Address.from_public_key_hash(:p2pkh) &quot;1Ak9NVPmwCHEpsSWvM6cNRC7dsYniRmwMG&quot;","ref":"BitcoinLib.Key.Address.html#from_public_key_hash/2","title":"BitcoinLib.Key.Address.from_public_key_hash/2","type":"function"},{"doc":"Can parse derivation paths string format into a native format m / purpose' / coin_type' / account' / change / address_index Inspired by https://github.com/bitcoin/bips/blob/master/bip-0044.mediawiki https://learnmeabitcoin.com/technical/derivation-paths","ref":"BitcoinLib.Key.HD.DerivationPath.html","title":"BitcoinLib.Key.HD.DerivationPath","type":"module"},{"doc":"Transforms a derivation path string into an elixir structure Examples iex&gt; &quot;m / 44' / 1' / 2' / 1 / 4&quot; ...&gt; |&gt; BitcoinLib.Key.HD.DerivationPath.parse() { :ok, % BitcoinLib.Key.HD.DerivationPath { type : :private , purpose : :bip44 , coin_type : :bitcoin_testnet , account : % BitcoinLib.Key.HD.DerivationPath.Level { hardened? : true , value : 2 } , change : :change_chain , address_index : % BitcoinLib.Key.HD.DerivationPath.Level { hardened? : false , value : 4 } } }","ref":"BitcoinLib.Key.HD.DerivationPath.html#parse/1","title":"BitcoinLib.Key.HD.DerivationPath.parse/1","type":"function"},{"doc":"","ref":"BitcoinLib.Key.HD.DerivationPath.Level.html","title":"BitcoinLib.Key.HD.DerivationPath.Level","type":"module"},{"doc":"Computing entropy from different sources, mostly for mnemonic seed creation","ref":"BitcoinLib.Key.HD.Entropy.html","title":"BitcoinLib.Key.HD.Entropy","type":"module"},{"doc":"Takes a list of dice rolls as a string argument, having values ranging from 0 to 5, transforming them into a single integer that could serve as entropy for mnemonic seed creation Examples iex&gt; &quot;12345612345612345612345612345612345612345612345612&quot; ...&gt; |&gt; BitcoinLib.Key.HD.Entropy.from_dice_rolls!() 32_310_461_525_491_050_757_677_748_469_648_273_221","ref":"BitcoinLib.Key.HD.Entropy.html#from_dice_rolls!/1","title":"BitcoinLib.Key.HD.Entropy.from_dice_rolls!/1","type":"function"},{"doc":"Takes a list of dice rolls as a string argument, having values ranging from 0 to 5, transforming them into a single integer that could serve as entropy for mnemonic seed creation Examples iex&gt; &quot;12345612345612345612345612345612345612345612345612&quot; ...&gt; |&gt; BitcoinLib.Key.HD.Entropy.from_dice_rolls() ...&gt; |&gt; elem(1) 32_310_461_525_491_050_757_677_748_469_648_273_221","ref":"BitcoinLib.Key.HD.Entropy.html#from_dice_rolls/1","title":"BitcoinLib.Key.HD.Entropy.from_dice_rolls/1","type":"function"},{"doc":"Bitcoin extended private key management module","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html","title":"BitcoinLib.Key.HD.ExtendedPrivate","type":"module"},{"doc":"Simply calls from_derivation_path and directly returns the private key whatever the outcome.any() Will crash if the index is negative or greater than 0x7FFFFFFF Examples iex&gt; private_key = %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0xf79bb0d317b310b261a55a8ab393b4c8a1aba6fa4d08aef379caba502d5d67f9, ...&gt; chain_code: 0x463223aac10fb13f291a1bc76bc26003d98da661cb76df61e750c139826dea8b ...&gt; } ...&gt; index = 0 ...&gt; BitcoinLib.Key.HD.ExtendedPrivate.derive_child!(private_key, index) %BitcoinLib.Key.HD.ExtendedPrivate{ key : 0x39f329fedba2a68e2a804fcd9aeea4104ace9080212a52ce8b52c1fb89850c72 , chain_code : 0x05aae71d7c080474efaab01fa79e96f4c6cfe243237780b0df4bc36106228e31 , depth : 1 , index : 0 , parent_fingerprint : 0x18C1259 }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#derive_child!/3","title":"BitcoinLib.Key.HD.ExtendedPrivate.derive_child!/3","type":"function"},{"doc":"Derives the nth child of a HD private key Takes a private key, its chain code and the child's index Returns the child's private key and it's associated chain code Inspired by https://learnmeabitcoin.com/technical/extended-keys#child-extended-key-derivation Examples iex&gt; private_key = %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0xf79bb0d317b310b261a55a8ab393b4c8a1aba6fa4d08aef379caba502d5d67f9, ...&gt; chain_code: 0x463223aac10fb13f291a1bc76bc26003d98da661cb76df61e750c139826dea8b ...&gt; } ...&gt; index = 0 ...&gt; BitcoinLib.Key.HD.ExtendedPrivate.derive_child(private_key, index) { :ok , % BitcoinLib.Key.HD.ExtendedPrivate { key : 0x39f329fedba2a68e2a804fcd9aeea4104ace9080212a52ce8b52c1fb89850c72 , chain_code : 0x05aae71d7c080474efaab01fa79e96f4c6cfe243237780b0df4bc36106228e31 , depth : 1 , index : 0 , parent_fingerprint : 0x18C1259 } }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#derive_child/3","title":"BitcoinLib.Key.HD.ExtendedPrivate.derive_child/3","type":"function"},{"doc":"Deserialization of a private key from its xpriv version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; &quot;xprv9s21ZrQH143K3QTDL4LXw2F7HEK3wJUD2nW2nRk4stbPy6cq3jPPqjiChkVvvNKmPGJxWUtg6LnF5kejMRNNU3TGtRBeJgk33yuGBxrMPHi&quot; ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPrivate.deserialize() %BitcoinLib.Key.HD.ExtendedPrivate { key : 0xE8F32E723DECF4051AEFAC8E2C93C9C5B214313817CDB01A1494B917C8436B35 , chain_code : 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 , depth : 0 , index : 0 , parent_fingerprint : 0 }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#deserialize/1","title":"BitcoinLib.Key.HD.ExtendedPrivate.deserialize/1","type":"function"},{"doc":"Simply calls from_derivation_path and directly returns the private key whatever the outcome.any() Will crash if used with an invalid derivation path Examples iex&gt; private_key = %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0xF79BB0D317B310B261A55A8AB393B4C8A1ABA6FA4D08AEF379CABA502D5D67F9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; {:ok, derivation_path} = BitcoinLib.Key.HD.DerivationPath.parse(&quot;m/44'&quot;) ...&gt; BitcoinLib.Key.HD.ExtendedPrivate.from_derivation_path!(private_key, derivation_path) %BitcoinLib.Key.HD.ExtendedPrivate{ key : 0x4E59086C1DEC6D081986CB079F536E38B3D2B6DA7A8EDCFFB1942AE8B9FDF156 , chain_code : 0xF42DE823EE78F6227822D79BC6F6101D084D7F0F876B7828BF027D681294E538 , depth : 1 , index : 0x8000002C , parent_fingerprint : 0x18C1259 }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#from_derivation_path!/2","title":"BitcoinLib.Key.HD.ExtendedPrivate.from_derivation_path!/2","type":"function"},{"doc":"Derives a child private key, following a derivation path Examples iex&gt; private_key = %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0xF79BB0D317B310B261A55A8AB393B4C8A1ABA6FA4D08AEF379CABA502D5D67F9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; {:ok, derivation_path} = BitcoinLib.Key.HD.DerivationPath.parse(&quot;m/44'&quot;) ...&gt; BitcoinLib.Key.HD.ExtendedPrivate.from_derivation_path(private_key, derivation_path) { :ok , % BitcoinLib.Key.HD.ExtendedPrivate { key : 0x4E59086C1DEC6D081986CB079F536E38B3D2B6DA7A8EDCFFB1942AE8B9FDF156 , chain_code : 0xF42DE823EE78F6227822D79BC6F6101D084D7F0F876B7828BF027D681294E538 , depth : 1 , index : 0x8000002C , parent_fingerprint : 0x18C1259 } }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#from_derivation_path/2","title":"BitcoinLib.Key.HD.ExtendedPrivate.from_derivation_path/2","type":"function"},{"doc":"Converts a mnemonic phrase into an extended private key Examples iex&gt; &quot;rally celery split order almost twenty ignore record legend learn chaos decade&quot; ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPrivate.from_mnemonic_phrase() %BitcoinLib.Key.HD.ExtendedPrivate{ fingerprint : 0x2E92A74C , key : 0xD6EAD233E06C068585976B5C8373861D77E7F030EC452E65EE81C85FA6906970 , chain_code : 0xA17100DD000D9D4A37034F7CEE0D46F5AE97B570BE065E57A00546FAE014A8A2 , depth : 0x0 , index : 0x0 }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#from_mnemonic_phrase/2","title":"BitcoinLib.Key.HD.ExtendedPrivate.from_mnemonic_phrase/2","type":"function"},{"doc":"Converts a seed into a master private key hash containing the key itself and the chain code Examples iex&gt; &quot;7e4803bd0278e223532f5833d81605bedc5e16f39c49bdfff322ca83d444892ddb091969761ea406bee99d6ab613fad6a99a6d4beba66897b252f00c9dd7b364&quot; ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPrivate.from_seed() %BitcoinLib.Key.HD.ExtendedPrivate{ chain_code : 0x5A7AEBB0FBE37BB89E690A6E350FAFED353B624741269E71001E608732FD8125 , key : 0x41DF6FA7F014A60FD79EC50B201FECF9CEDD8328921DDF670ACFCEF227242688 , fingerprint : 0xB317B417 }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#from_seed/1","title":"BitcoinLib.Key.HD.ExtendedPrivate.from_seed/1","type":"function"},{"doc":"Serialization of a master private key into its xpriv version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; %BitcoinLib.Key.HD.ExtendedPrivate { ...&gt; key: 0xE8F32E723DECF4051AEFAC8E2C93C9C5B214313817CDB01A1494B917C8436B35, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPrivate.serialize() &quot;xprv9s21ZrQH143K3QTDL4LXw2F7HEK3wJUD2nW2nRk4stbPy6cq3jPPqjiChkVvvNKmPGJxWUtg6LnF5kejMRNNU3TGtRBeJgk33yuGBxrMPHi&quot;","ref":"BitcoinLib.Key.HD.ExtendedPrivate.html#serialize/1","title":"BitcoinLib.Key.HD.ExtendedPrivate.serialize/1","type":"function"},{"doc":"Computes a private key from a derivation path","ref":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromDerivationPath.html","title":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromDerivationPath","type":"module"},{"doc":"Computes a private key from a derivation path Examples iex&gt; { :ok, derivation_path } = BitcoinLib.Key.HD.DerivationPath.parse(&quot;m/84'/0'/0'/0/0&quot;) ...&gt; %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0xF79BB0D317B310B261A55A8AB393B4C8A1ABA6FA4D08AEF379CABA502D5D67F9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPrivate.ChildFromDerivationPath.get(derivation_path) { :ok , % BitcoinLib.Key.HD.ExtendedPrivate { key : 0x210DDF6EA57B57C4607B17F9774C3F48AC92DA3AE5FF03D215CCE56AA021DAA6 , chain_code : 0x143B6DAC88591B42BD7D74AA193D4EFC7826873B4BD5F491B7067E705B8A626E , depth : 5 , index : 0 , parent_fingerprint : 0xFFF4D449 } }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromDerivationPath.html#get/2","title":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromDerivationPath.get/2","type":"function"},{"doc":"Calculates direct childs from a private key based on a given index, and maybe a hardened flag","ref":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromIndex.html","title":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromIndex","type":"module"},{"doc":"Calculates a direct child from a private key based on a given index, and maybe a hardened flag Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0xF79BB0D317B310B261A55A8AB393B4C8A1ABA6FA4D08AEF379CABA502D5D67F9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPrivate.ChildFromIndex.get(0) { :ok , % BitcoinLib.Key.HD.ExtendedPrivate { key : 0x39F329FEDBA2A68E2A804FCD9AEEA4104ACE9080212A52CE8B52C1FB89850C72 , chain_code : 0x05AAE71D7C080474EFAAB01FA79E96F4C6CFE243237780B0DF4BC36106228E31 , depth : 1 , index : 0 , parent_fingerprint : 0x18C1259 } }","ref":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromIndex.html#get/3","title":"BitcoinLib.Key.HD.ExtendedPrivate.ChildFromIndex.get/3","type":"function"},{"doc":"Bitcoin extended public key management module","ref":"BitcoinLib.Key.HD.ExtendedPublic.html","title":"BitcoinLib.Key.HD.ExtendedPublic","type":"module"},{"doc":"Simply calls from_derivation_path and directly returns the public key whatever the outcome.any() Will crash if the index is negative or greater than 0x7FFFFFFF Examples iex&gt; public_key = %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; index = 0 ...&gt; BitcoinLib.Key.HD.ExtendedPublic.derive_child!(public_key, index) %BitcoinLib.Key.HD.ExtendedPublic{ key : 0x30204D3503024160E8303C0042930EA92A9D671DE9AA139C1867353F6B6664E59 , chain_code : 0x05AAE71D7C080474EFAAB01FA79E96F4C6CFE243237780B0DF4BC36106228E31 , depth : 1 , index : 0 , parent_fingerprint : 0x18C1259 , fingerprint : 0x9680603F }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#derive_child!/2","title":"BitcoinLib.Key.HD.ExtendedPublic.derive_child!/2","type":"function"},{"doc":"Derives the nth child of a HD public key Takes a public key, its chain code and the child's index Returns the child's public key and it's associated chain code Inspired by https://learnmeabitcoin.com/technical/extended-keys#child-extended-key-derivation Examples iex&gt; public_key = %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; index = 0 ...&gt; BitcoinLib.Key.HD.ExtendedPublic.derive_child(public_key, index) { :ok , % BitcoinLib.Key.HD.ExtendedPublic { key : 0x30204D3503024160E8303C0042930EA92A9D671DE9AA139C1867353F6B6664E59 , chain_code : 0x05AAE71D7C080474EFAAB01FA79E96F4C6CFE243237780B0DF4BC36106228E31 , depth : 1 , index : 0 , parent_fingerprint : 0x18C1259 , fingerprint : 0x9680603F } }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#derive_child/2","title":"BitcoinLib.Key.HD.ExtendedPublic.derive_child/2","type":"function"},{"doc":"Deserialization of a public key from its xpub version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; &quot;xpub661MyMwAqRbcFtXgS5sYJABqqG9YLmC4Q1Rdap9gSE8NqtwybGhePY2gZ29ESFjqJoCu1Rupje8YtGqsefD265TMg7usUDFdp6W1EGMcet8&quot; ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.deserialize!() %BitcoinLib.Key.HD.ExtendedPublic{ fingerprint : 0x3442193E , key : 0x339A36013301597DAEF41FBE593A02CC513D0B55527EC2DF1050E2E8FF49C85C2 , chain_code : 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 , depth : 0 , index : 0 , parent_fingerprint : 0 }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#deserialize!/1","title":"BitcoinLib.Key.HD.ExtendedPublic.deserialize!/1","type":"function"},{"doc":"Deserialization of a public key from its xpub version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; &quot;xpub661MyMwAqRbcFtXgS5sYJABqqG9YLmC4Q1Rdap9gSE8NqtwybGhePY2gZ29ESFjqJoCu1Rupje8YtGqsefD265TMg7usUDFdp6W1EGMcet8&quot; ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.deserialize() { :ok , % BitcoinLib.Key.HD.ExtendedPublic { fingerprint : 0x3442193E , key : 0x339A36013301597DAEF41FBE593A02CC513D0B55527EC2DF1050E2E8FF49C85C2 , chain_code : 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 , depth : 0 , index : 0 , parent_fingerprint : 0 } }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#deserialize/1","title":"BitcoinLib.Key.HD.ExtendedPublic.deserialize/1","type":"function"},{"doc":"Derives a child public key, following a derivation path Examples iex&gt; public_key = %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; {:ok, derivation_path} = BitcoinLib.Key.HD.DerivationPath.parse(&quot;M/44'/0'/0'/0/0&quot;) ...&gt; BitcoinLib.Key.HD.ExtendedPublic.from_derivation_path(public_key, derivation_path) { :ok , % BitcoinLib.Key.HD.ExtendedPublic { key : 0x29DCAFD0D7D67B13657CC9EE7C8976E141F20F0684BF3FC83CAF068E74186BCDC , chain_code : 0x162EEE68F7C3823CAF8BD2615A4A33633673CAAB66FF6F338FB0653FC59D462D , depth : 5 , index : 0 , parent_fingerprint : 0xCA2A5281 , fingerprint : 0xAEAAB1AD } }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#from_derivation_path/2","title":"BitcoinLib.Key.HD.ExtendedPublic.from_derivation_path/2","type":"function"},{"doc":"Derives an extended public key from an extended private key. Happens to be the same process as for regular keys. Inspired by https://learnmeabitcoin.com/technical/hd-wallets#master-private-key Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPrivate{ ...&gt; key: 0x081549973BAFBBA825B31BCC402A3C4ED8E3185C2F3A31C75E55F423E9629AA3, ...&gt; chain_code: 0x1D7D2A4C940BE028B945302AD79DD2CE2AFE5ED55E1A2937A5AF57F8401E73DD ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.from_private_key() %BitcoinLib.Key.HD.ExtendedPublic{ fingerprint : 0xED104CB8 , key : 0x0343B337DEC65A47B3362C9620A6E6FF39A1DDFA908ABAB1666C8A30A3F8A7CCCC , chain_code : 0x1D7D2A4C940BE028B945302AD79DD2CE2AFE5ED55E1A2937A5AF57F8401E73DD , depth : 0 , index : 0 , parent_fingerprint : 0 }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#from_private_key/1","title":"BitcoinLib.Key.HD.ExtendedPublic.from_private_key/1","type":"function"},{"doc":"Computes a public key hash out of a public key Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x0343B337DEC65A47B3362C9620A6E6FF39A1DDFA908ABAB1666C8A30A3F8A7CCCC, ...&gt; chain_code: 0x1D7D2A4C940BE028B945302AD79DD2CE2AFE5ED55E1A2937A5AF57F8401E73DD ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.get_hash() 0xED104CB8EF3ADABEC5D2BE8178C99847F9694269","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#get_hash/1","title":"BitcoinLib.Key.HD.ExtendedPublic.get_hash/1","type":"function"},{"doc":"Serialization of a master public key into its xpub version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x339A36013301597DAEF41FBE593A02CC513D0B55527EC2DF1050E2E8FF49C85C2, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508, ...&gt; depth: 0, ...&gt; index: 0, ...&gt; parent_fingerprint: 0 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.serialize!() &quot;xpub661MyMwAqRbcFtXgS5sYJABqqG9YLmC4Q1Rdap9gSE8NqtwybGhePY2gZ29ESFjqJoCu1Rupje8YtGqsefD265TMg7usUDFdp6W1EGMcet8&quot;","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#serialize!/2","title":"BitcoinLib.Key.HD.ExtendedPublic.serialize!/2","type":"function"},{"doc":"Serialization of a master public key into its xpub version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x339A36013301597DAEF41FBE593A02CC513D0B55527EC2DF1050E2E8FF49C85C2, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508, ...&gt; depth: 0, ...&gt; index: 0, ...&gt; parent_fingerprint: 0 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.serialize() { :ok , &quot;xpub661MyMwAqRbcFtXgS5sYJABqqG9YLmC4Q1Rdap9gSE8NqtwybGhePY2gZ29ESFjqJoCu1Rupje8YtGqsefD265TMg7usUDFdp6W1EGMcet8&quot; }","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#serialize/2","title":"BitcoinLib.Key.HD.ExtendedPublic.serialize/2","type":"function"},{"doc":"Converts the public key to an address of the type specified as the second parameter Defaults to bech32 address type Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x3EB181FB7B5CF63D82307188B20828B83008F2D2511E5C6EDCBE171C63DD2CBC1, ...&gt; chain_code: 0x581F15490635CF8CD0AEEF556562F52C60179E0E87E0EA92977E364D949DC2E4, ...&gt; depth: 0x5, ...&gt; index: 0x0 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.to_address(:p2pkh) &quot;1BRjWnoAVg3EASJHex5YeyDWC1zZ4CA5vc&quot;","ref":"BitcoinLib.Key.HD.ExtendedPublic.html#to_address/2","title":"BitcoinLib.Key.HD.ExtendedPublic.to_address/2","type":"function"},{"doc":"","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.html","title":"BitcoinLib.Key.HD.ExtendedPublic.Address","type":"module"},{"doc":"","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.html#from_extended_public_key/2","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.from_extended_public_key/2","type":"function"},{"doc":"Implementation of Bech32 addresses BIP173: https://en.bitcoin.it/wiki/BIP_0173 Sources: https://en.bitcoin.it/wiki/Bech32 https://bitcointalk.org/index.php?topic=4992632.0","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.Bech32.html","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.Bech32","type":"module"},{"doc":"Creates a Bech32 address, which is starting by bc1, out of an Extended Public Key Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x0279BE667EF9DCBBAC55A06295CE870B07029BFCDB2DCE28D959F2815B16F81798, ...&gt; chain_code: 0 ...&gt; } |&gt; BitcoinLib.Key.HD.ExtendedPublic.Address.Bech32.from_extended_public_key() &quot;bc1qw508d6qejxtdg4y5r3zarvary0c5xw7kv8f3t4&quot;","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.Bech32.html#from_extended_public_key/1","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.Bech32.from_extended_public_key/1","type":"function"},{"doc":"Implementation of P2PKH addresses Sources: https://learnmeabitcoin.com/technical/address#pay-to-pubkey-hash-p2pkh https://en.bitcoinwiki.org/wiki/Pay-to-Pubkey_Hash","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2PKH.html","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2PKH","type":"module"},{"doc":"Converts an extended public key into a P2PKH address starting by 1 Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x02D0DE0AAEAEFAD02B8BDC8A01A1B8B11C696BD3D66A2C5F10780D95B7DF42645C, ...&gt; chain_code: 0 ...&gt; } |&gt; BitcoinLib.Key.HD.ExtendedPublic.Address.P2PKH.from_extended_public_key() &quot;1LoVGDgRs9hTfTNJNuXKSpywcbdvwRXpmK&quot;","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2PKH.html#from_extended_public_key/1","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2PKH.from_extended_public_key/1","type":"function"},{"doc":"Implementation of P2SH-P2WPKH addresses BIP13: Address Format for pay-to-script-hash https://github.com/bitcoin/bips/blob/master/bip-0013.mediawiki BIP16: Pay to Script Hash https://github.com/bitcoin/bips/blob/master/bip-0016.mediawiki Source: https://github.com/bitcoin/bips/blob/master/bip-0013.mediawiki","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2SH.html","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2SH","type":"module"},{"doc":"Creates a P2SH-P2WPKH address, which is starting by 3, out of an Extended Public Key Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x02D0DE0AAEAEFAD02B8BDC8A01A1B8B11C696BD3D66A2C5F10780D95B7DF42645C, ...&gt; chain_code: 0 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.Address.P2SH.from_extended_public_key() &quot;3D9iyFHi1Zs9KoyynUfrL82rGhJfYTfSG4&quot;","ref":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2SH.html#from_extended_public_key/1","title":"BitcoinLib.Key.HD.ExtendedPublic.Address.P2SH.from_extended_public_key/1","type":"function"},{"doc":"Computes a public key from a derivation path","ref":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromDerivationPath.html","title":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromDerivationPath","type":"module"},{"doc":"Computes a public key from a derivation path Examples iex&gt; { :ok, derivation_path } = BitcoinLib.Key.HD.DerivationPath.parse(&quot;M/84'/0'/0'/0/0&quot;) ...&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.ChildFromDerivationPath.get(derivation_path) { :ok , % BitcoinLib.Key.HD.ExtendedPublic { key : 0x3D8E202D3D91B13E955D79BA88EADD709B98640D9633868C6274B9ACEED0F70EF , chain_code : 0x3159D0A560A856F5894C15EB0D657A74218B4979D8C6D76F8E78A42C83D22DA8 , depth : 5 , index : 0 , parent_fingerprint : 0x3E4142F6 , fingerprint : 0xD0D8EFE4 } }","ref":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromDerivationPath.html#get/2","title":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromDerivationPath.get/2","type":"function"},{"doc":"Calculates direct childs from a public key based on a given index","ref":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromIndex.html","title":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromIndex","type":"module"},{"doc":"Calculates a direct child from a public key based on a given index Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.ChildFromIndex.get(0) { :ok , % BitcoinLib.Key.HD.ExtendedPublic { fingerprint : 0x9680603F , key : 0x30204D3503024160E8303C0042930EA92A9D671DE9AA139C1867353F6B6664E59 , chain_code : 0x05AAE71D7C080474EFAAB01FA79E96F4C6CFE243237780B0DF4BC36106228E31 , depth : 1 , index : 0 , parent_fingerprint : 0x18C1259 } }","ref":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromIndex.html#get/2","title":"BitcoinLib.Key.HD.ExtendedPublic.ChildFromIndex.get/2","type":"function"},{"doc":"","ref":"BitcoinLib.Key.HD.ExtendedPublic.Deserialization.html","title":"BitcoinLib.Key.HD.ExtendedPublic.Deserialization","type":"module"},{"doc":"Deserialization of a public key from its xpub version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; &quot;xpub661MyMwAqRbcFtXgS5sYJABqqG9YLmC4Q1Rdap9gSE8NqtwybGhePY2gZ29ESFjqJoCu1Rupje8YtGqsefD265TMg7usUDFdp6W1EGMcet8&quot; ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.deserialize() %BitcoinLib.Key.HD.ExtendedPublic{ key : 0x339A36013301597DAEF41FBE593A02CC513D0B55527EC2DF1050E2E8FF49C85C2 , chain_code : 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 , depth : 0 , index : 0 , parent_fingerprint : 0 }","ref":"BitcoinLib.Key.HD.ExtendedPublic.Deserialization.html#deserialize/1","title":"BitcoinLib.Key.HD.ExtendedPublic.Deserialization.deserialize/1","type":"function"},{"doc":"Extended public key serialization module To test the results, use https://www.npmjs.com/package/@swan-bitcoin/xpub-cli Serialization types: https://github.com/satoshilabs/slips/blob/master/slip-0132.md","ref":"BitcoinLib.Key.HD.ExtendedPublic.Serialization.html","title":"BitcoinLib.Key.HD.ExtendedPublic.Serialization","type":"module"},{"doc":"Serialization of a master public key into an exportable version Examples values from https://github.com/bitcoin/bips/blob/master/bip-0032.mediawiki#test-vector-1 iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x339A36013301597DAEF41FBE593A02CC513D0B55527EC2DF1050E2E8FF49C85C2, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508, ...&gt; depth: 0, ...&gt; index: 0, ...&gt; parent_fingerprint: 0 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.ExtendedPublic.Serialization.serialize() { :ok , &quot;xpub661MyMwAqRbcFtXgS5sYJABqqG9YLmC4Q1Rdap9gSE8NqtwybGhePY2gZ29ESFjqJoCu1Rupje8YtGqsefD265TMg7usUDFdp6W1EGMcet8&quot; }","ref":"BitcoinLib.Key.HD.ExtendedPublic.Serialization.html#serialize/2","title":"BitcoinLib.Key.HD.ExtendedPublic.Serialization.serialize/2","type":"function"},{"doc":"A fingerprint is a small hash of a public key","ref":"BitcoinLib.Key.HD.Fingerprint.html","title":"BitcoinLib.Key.HD.Fingerprint","type":"module"},{"doc":"Adds a fingerprint to a public key Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPrivate { ...&gt; key: 0xE8F32E723DECF4051AEFAC8E2C93C9C5B214313817CDB01A1494B917C8436B35, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.Fingerprint.append() %BitcoinLib.Key.HD.ExtendedPrivate { fingerprint : 0x3442193E , key : 0xE8F32E723DECF4051AEFAC8E2C93C9C5B214313817CDB01A1494B917C8436B35 , chain_code : 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 } iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.Fingerprint.append() %BitcoinLib.Key.HD.ExtendedPublic{ fingerprint : 0x18C1259 , key : 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9 , chain_code : 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B }","ref":"BitcoinLib.Key.HD.Fingerprint.html#append/1","title":"BitcoinLib.Key.HD.Fingerprint.append/1","type":"function"},{"doc":"Compute a private key's fingerprint Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPrivate { ...&gt; key: 0xE8F32E723DECF4051AEFAC8E2C93C9C5B214313817CDB01A1494B917C8436B35, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.Fingerprint.compute() 0x3442193E iex&gt; %BitcoinLib.Key.HD.ExtendedPublic{ ...&gt; key: 0x252C616D91A2488C1FD1F0F172E98F7D1F6E51F8F389B2F8D632A8B490D5F6DA9, ...&gt; chain_code: 0x463223AAC10FB13F291A1BC76BC26003D98DA661CB76DF61E750C139826DEA8B ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.Fingerprint.compute() 0x18C1259","ref":"BitcoinLib.Key.HD.Fingerprint.html#compute/1","title":"BitcoinLib.Key.HD.Fingerprint.compute/1","type":"function"},{"doc":"Computes HMAC on either a public or a private key in the aim of computing a child key","ref":"BitcoinLib.Key.HD.Hmac.html","title":"BitcoinLib.Key.HD.Hmac","type":"module"},{"doc":"Computes HMAC on either a public or a private key in the aim of computing a child key Examples iex&gt; %BitcoinLib.Key.HD.ExtendedPrivate { ...&gt; key: 0xE8F32E723DECF4051AEFAC8E2C93C9C5B214313817CDB01A1494B917C8436B35, ...&gt; chain_code: 0x873DFF81C02F525623FD1FE5167EAC3A55A049DE3D314BB42EE227FFED37D508 ...&gt; } ...&gt; |&gt; BitcoinLib.Key.HD.Hmac.compute(0) { 0x6539AE80B3618C22F5F8CC4171D04835570BDA8DB11B5BF1779AFAE7EC7C79C3 , 0xD323F1BE5AF39A2D2F08F5E8F664633849653DBE329802E9847CFC85F8D7B52A }","ref":"BitcoinLib.Key.HD.Hmac.html#compute/3","title":"BitcoinLib.Key.HD.Hmac.compute/3","type":"function"},{"doc":"Compute a mnemonic seed from a private key","ref":"BitcoinLib.Key.HD.MnemonicSeed.html","title":"BitcoinLib.Key.HD.MnemonicSeed","type":"module"},{"doc":"Convert a mnemonic phrase into a seed, with a optional passphrase Examples iex&gt; &quot;brick giggle panic mammal document foam gym canvas wheel among room analyst&quot; ...&gt; |&gt; BitcoinLib.Key.HD.MnemonicSeed.to_seed() &quot;7e4803bd0278e223532f5833d81605bedc5e16f39c49bdfff322ca83d444892ddb091969761ea406bee99d6ab613fad6a99a6d4beba66897b252f00c9dd7b364&quot;","ref":"BitcoinLib.Key.HD.MnemonicSeed.html#to_seed/2","title":"BitcoinLib.Key.HD.MnemonicSeed.to_seed/2","type":"function"},{"doc":"Convert a random entropy number into a mnemonic seed Examples iex&gt; 101_750_443_022_601_924_635_824_320_539_097_414_732 ...&gt; |&gt; BitcoinLib.Key.HD.MnemonicSeed.wordlist_from_entropy() &quot;erode gloom apart system broom lemon dismiss post artist slot humor occur&quot;","ref":"BitcoinLib.Key.HD.MnemonicSeed.html#wordlist_from_entropy/1","title":"BitcoinLib.Key.HD.MnemonicSeed.wordlist_from_entropy/1","type":"function"},{"doc":"Checksum needed to generate a mnemonic seed Source: https://raw.githubusercontent.com/bitcoin/bips/master/bip-0039/english.txt","ref":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.html","title":"BitcoinLib.Key.HD.MnemonicSeed.Checksum","type":"module"},{"doc":"Computes the checksum, which is the first few bits of a SHA256 hash Examples iex&gt; &lt;&lt;27, 172, 62, 126, 195, 84, 6, 180, 26, 1, 13, 250, 0, 254, 239, 132&gt;&gt; ...&gt; |&gt; BitcoinLib.Key.HD.MnemonicSeed.Checksum.compute(4) 2","ref":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.html#compute/2","title":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.compute/2","type":"function"},{"doc":"Adds checksum at the end of the seed","ref":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.html#compute_and_append_to_seed/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.compute_and_append_to_seed/1","type":"function"},{"doc":"","ref":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.html#number_of_checksum_bits/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.number_of_checksum_bits/1","type":"function"},{"doc":"Computes the checksum, and verify that it matches to the one received Examples iex&gt; &lt;&lt;5, 235, 104, 86, 249, 249, 27, 246, 234, 99, 13, 18, 209, 116, 50, 248, 35&gt;&gt; ...&gt; |&gt; BitcoinLib.Key.HD.MnemonicSeed.Checksum.validate_seed() true","ref":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.html#validate_seed/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Checksum.validate_seed/1","type":"function"},{"doc":"A list of all the words that can be contained in a private key seed Source: https://raw.githubusercontent.com/bitcoin/bips/master/bip-0039/english.txt","ref":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.html","title":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist","type":"module"},{"doc":"Get a list of all words in the wordlist Examples iex&gt; BitcoinLib.Key.HD.MnemonicSeed.Wordlist.all ...&gt; |&gt; Enum.count() 2048","ref":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.html#all/0","title":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.all/0","type":"function"},{"doc":"Convert a word into an indice from the wordlist Examples iex&gt; BitcoinLib.Key.HD.MnemonicSeed.Wordlist . get_indice ( &quot;absurd&quot; ) { :found , 8 , &quot;absurd&quot; }","ref":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.html#get_indice/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_indice/1","type":"function"},{"doc":"Convert a list of words into a list of indices from the wordlist Examples iex&gt; [&quot;absurd&quot;, &quot;able&quot;, &quot;absent&quot;] ...&gt; |&gt; BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_indices() [8, 2, 5]","ref":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.html#get_indices/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_indices/1","type":"function"},{"doc":"Get a single word from the wordlist by index Examples iex&gt; BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_word(8) &quot;absurd&quot;","ref":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.html#get_word/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_word/1","type":"function"},{"doc":"Convert a list of indices into words from the wordlist Examples iex&gt; BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_words([8, 2, 5]) [&quot;absurd&quot;, &quot;able&quot;, &quot;absent&quot;]","ref":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.html#get_words/1","title":"BitcoinLib.Key.HD.MnemonicSeed.Wordlist.get_words/1","type":"function"},{"doc":"Bitcoin private key management module","ref":"BitcoinLib.Key.Private.html","title":"BitcoinLib.Key.Private","type":"module"},{"doc":"Creates a Bitcoin private key using efficient randomness Inspired by https://learnmeabitcoin.com/technical/private-key Examples iex&gt; %{raw: raw1} = BitcoinLib.Key.Private.generate ...&gt; %{raw: raw2} = BitcoinLib.Key.Private.generate ...&gt; raw1 == raw2 false","ref":"BitcoinLib.Key.Private.html#generate/0","title":"BitcoinLib.Key.Private.generate/0","type":"function"},{"doc":"Converts a binary primary key to the WIF format Based on https://learnmeabitcoin.com/technical/wif Examples iex&gt; 0x6C7AB2F961A1BC3F13CDC08DC41C3F439ADEBD549A8EF1C089E81A5907376107 ...&gt; |&gt; BitcoinLib.Key.Private.to_wif() &quot;KzractrYn5gnDNVwBDy7sYhAkyMvX4WeYQpwyhCAUKDogJTzYsUc&quot;","ref":"BitcoinLib.Key.Private.html#to_wif/1","title":"BitcoinLib.Key.Private.to_wif/1","type":"function"},{"doc":"Bitcoin public key management module","ref":"BitcoinLib.Key.Public.html","title":"BitcoinLib.Key.Public","type":"module"},{"doc":"Derives a public key from a private key in both uncompressed and compressed format Based on https://learnmeabitcoin.com/technical/public-key Examples iex&gt; 0x0a8d286b11b98f6cb2585b627ff44d12059560acd430dcfa1260ef2bd9569373 ...&gt; |&gt; BitcoinLib.Key.Public.from_private_key { 0x040f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053002119e16b613619691f760eadd486315fc9e36491c7adb76998d1b903b3dd12 , 0x020f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053 }","ref":"BitcoinLib.Key.Public.html#from_private_key/1","title":"BitcoinLib.Key.Public.from_private_key/1","type":"function"},{"doc":"Bitcoin Public Key Hash module","ref":"BitcoinLib.Key.PublicHash.html","title":"BitcoinLib.Key.PublicHash","type":"module"},{"doc":"Extract a public key hash from a bitcoin public key Inspired by https://learnmeabitcoin.com/technical/public-key-hash Examples iex&gt; 0x02b4632d08485ff1df2db55b9dafd23347d1c47a457072a1e87be26896549a8737 ...&gt; |&gt; BitcoinLib.Key.PublicHash.from_public_key() 0x93ce48570b55c42c2af816aeaba06cfee1224fae","ref":"BitcoinLib.Key.PublicHash.html#from_public_key/1","title":"BitcoinLib.Key.PublicHash.from_public_key/1","type":"function"},{"doc":"Want to interact with the Bitcoin network through a DIY app? Look no further, this library is about doing it with Elixir in a very abstract way. It keeps the cryptography jargon to a minimum, while sticking to the Bitcoin glossary . How to use First, make sure you've got elixir set up and that you know the language's basics . Then, create a project and add the dependency in mix.exs . def deps do [ { :bitcoinlib , &quot;~&gt; 0.1.3&quot; } ] end Finally, head to the private key creation documentation to get started. Useful links Here are the most useful links Hex package Hex documentation Git repository Useful links Examples Technicalities","ref":"readme.html","title":"BitcoinLib","type":"extras"},{"doc":"Generate entropy with dice rolls Create private keys Derive public keys from private keys Handle Hierarchical Deterministic (HD) Wallets, including Mnemonic Phrases Derivation Paths Serialize/Deserialize Private Keys ( xprv , yprv , zprv ) Serialize/Deserialize Public Keys ( xpub , ypub , zpub ) Generate Addresses Mid term goals Sign Transactions (PSBT) Taproot support","ref":"readme.html#this-lib-can","title":"BitcoinLib - This lib can","type":"extras"},{"doc":"Address Type Description Starts With Supported P2PKH Pay to Primary Key Hash 1 ✅ P2WPKH-nested-in-P2SH Nested Segwit 3 ✅ P2WPKH Native Segwit bc1q ✅ P2TR Taproot bc1p Eventually...","ref":"readme.html#supported-address-types","title":"BitcoinLib - Supported address types","type":"extras"},{"doc":"A bip is a Bitcoin Improvement Proposal . Here is a list of those that are at least partially implemented in this library: bip13 - Address Format for pay-to-script-hash bip16 - Pay to Script Hash bip32 - Hierarchical Deterministic Wallets bip39 - Mnemonic code for generating deterministic keys bip44 - Multi-Account Hierarchy for Deterministic Wallets bip49 - Derivation scheme for P2WPKH-nested-in-P2SH based accounts bip84 - Derivation scheme for P2WPKH based accounts bip141 - Segregated Witness (Consensus layer) bip173 - Base32 address format for native v0-16 witness outputs","ref":"readme.html#referenced-bips","title":"BitcoinLib - Referenced bips","type":"extras"},{"doc":"","ref":"examples.html","title":"Examples","type":"extras"},{"doc":"%{ raw : private_key , wif : wif_version } = BitcoinLib . generate_private_key ( ) %{ raw : 85802653936839865013864937414198608060921225918071701559735074585839951298352 , wif : &quot;L3aTXceEuyR8roYKSjY4yw6GYchZSRmxoKLHpUKJYkNGeLwccE6b&quot; }","ref":"examples.html#private-key-generation","title":"Examples - Private key generation","type":"extras"},{"doc":"private_key = &quot;0a8d286b11b98f6cb2585b627ff44d12059560acd430dcfa1260ef2bd9569373&quot; { uncompressed , compressed } = private_key |&gt; BitcoinLib . derive_public_key ( ) { &quot;040f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053002119e16b613619691f760eadd486315fc9e36491c7adb76998d1b903b3dd12&quot; , &quot;020f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053&quot; | }","ref":"examples.html#public-key-derivation","title":"Examples - Public key derivation","type":"extras"},{"doc":"compressed_public_key = &quot;020f69ef8f2feb09b29393eef514761f22636b90d8e4d3f2138b2373bd37523053&quot; address = compressed_public_key |&gt; BitcoinLib . generate_p2pkh_address ( ) 1 Ak9NVPmwCHEpsSWvM6cNRC7dsYniRmwMG","ref":"examples.html#generate-a-p2pkh-from-a-public-key","title":"Examples - Generate a P2PKH from a public key","type":"extras"},{"doc":"Output Types by Count Bech32 adoption BIP32 Deterministic Key Generator Registered HD version bytes","ref":"links.html","title":"External links","type":"extras"},{"doc":"The private key is your identity. You can use it to receive and spend funds, as well as view how much is associated with it. Banks ask for documents to prove who you are. In Bitcoin, all that's required is a very very large number that you can issue by yourself. The more random the number, the more secure are your funds. The way BitcoinLib deals with this is by creating entropy from dice rolls and then convert it into either a 12 or 24 words mnemonic phrase .","ref":"tutorial-private-key.html","title":"Private keys","type":"extras"},{"doc":"BitcoinLib offers a way to generate very random entropy by rolling 50 or 99 dices, depending on the level of security you're after. These will introduce either 2¹³² or 2²⁶⁴ possibilities, depending on the number of rolls. To get to a private key creation, we first need a mnemonic phrase. Dice rolls will thus be converted into words. These two notations are equivalent. Note here that every dice roll value has been reduced by 1 so that values range from 0 to 5. alias BitcoinLib.Key.HD . { Entropy , MnemonicSeed } &quot;12345612345612345612345612345612345612345612345612&quot; |&gt; Entropy . from_dice_rolls! ( ) |&gt; MnemonicSeed . wordlist_from_entropy ( ) This is the result &quot;blue involve cook print twist crystal razor february caution private slim medal&quot;","ref":"tutorial-private-key.html#mnemonic-phrase-from-dice-rolls","title":"Private keys - Mnemonic phrase from dice rolls","type":"extras"},{"doc":"This mnemonic phrase can then be converted into a private key alias BitcoinLib.Key.HD.ExtendedPrivate private_key = &quot;blue involve cook print twist crystal razor february caution private slim medal&quot; |&gt; ExtendedPrivate . from_mnemonic_phrase ( ) To keep things simple, we won't bother about what's returned as a private key... just know that this thing has full access to the wallet that's about to be created in the next steps.","ref":"tutorial-private-key.html#private-key-from-mnemonics","title":"Private keys - Private key from mnemonics","type":"extras"},{"doc":"A private key can be serialized into an xprv private_key |&gt; ExtendedPrivate . serialize which results in &quot;xprv9s21ZrQH143K4ES1UxgkqLcre6id6tttZRb5s5jQoqN5t7vUH1p5igi4DKw1E8Dh3EkGtAuKx2RXLTxjJs98uPctYxZrV9TFF1ECi9QNy95&quot; and can then be imported in a wallet, which will have full access to the funds","ref":"tutorial-private-key.html#serialization","title":"Private keys - Serialization","type":"extras"},{"doc":"For reference, is a very nice doc describing key derivation . At the moment, bip44 , bip49 and bip84 purposes are supported, with taproot being the next in line. Any extended private key can be derived using any of these purposes. Choosing the right one is important, as it will impact address types generated down the line.","ref":"tutorial-derivation.html","title":"Key derivation","type":"extras"},{"doc":"Starting from a mnemonic phrase, down to the private key &quot;blue involve cook print twist crystal razor february caution private slim medal&quot; |&gt; ExtendedPrivate . from_mnemonic_phrase ( ) |&gt; ExtendedPrivate . from_derivation_path! ( &quot;m/84&#39;/0&#39;/0&#39;&quot; ) This will result in a bitcoin bech32 private key that can further be derivated twice","ref":"tutorial-derivation.html#create-the-bip84-bitcoin-account-0","title":"Key derivation - Create the bip84 Bitcoin account #0","type":"extras"},{"doc":"A public key is derived from a private key . The main difference is that it can't be used to spend funds. It still is able to view balances and create addresses.","ref":"tutorial-public-key.html","title":"Public Keys","type":"extras"},{"doc":"First, a private key is needed... alias BitcoinLib.Key.HD.ExtendedPrivate private_key = &quot;blue involve cook print twist crystal razor february caution private slim medal&quot; |&gt; ExtendedPrivate . from_mnemonic_phrase ( ) ... it can then be converted into a public key public_key = private_key |&gt; ExtendedPublic . from_private_key","ref":"tutorial-public-key.html#creation","title":"Public Keys - Creation","type":"extras"},{"doc":"A public key can be serialized into an xpub public_key |&gt; ExtendedPublic . serialize! which results in &quot;xpub661MyMwAqRbcGiWUazDmCUZbC8Z7WMcjveWgfU92NAu4kvFcpZ8LGV2Y4bRaT8sBUzihLgiyMqsbb61HKFV1sL185uZs1DE15dpWfrQFqBY&quot; and can then be imported in an online app to generate a read-only wallet","ref":"tutorial-public-key.html#serialization","title":"Public Keys - Serialization","type":"extras"},{"doc":"Addresses are derived from a public key and can be used to receive funds or track balances.","ref":"tutorial-address.html","title":"Addresses","type":"extras"},{"doc":"First, we need a public key alias BitcoinLib.Key.HD.ExtendedPrivate public_key = &quot;blue involve cook print twist crystal razor february caution private slim medal&quot; |&gt; ExtendedPrivate . from_mnemonic_phrase ( ) |&gt; ExtendedPublic . from_private_key One public key corresponds to a single address... Here is how it's being converted public_key |&gt; ExtendedPublic . to_address which results in bc1q92hugrsmv52fr5fp2axycdg7fz4ssr66spdajs","ref":"tutorial-address.html#creation","title":"Addresses - Creation","type":"extras"}]